VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Log"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Class name : Log
'Description : an easy an very usefull object to add loging to a batch application,saves you the hassle of writing this kind
'               of code over and over again.
'Author : Stefan De Prins
'Mail : stefan.de.prins@pandora.be

Option Explicit
Private miFileNumber As Integer
Private mbFileHasBeenAssigned As Boolean
Private mvarTitle As String
Private coError As LogError

Public Property Get Error() As LogError
    Set Error = coError
End Property
Public Sub WriteLine(ByVal vsLine As String)
    If mbFileHasBeenAssigned Then
        Print #miFileNumber, vsLine
    Else
        coError.SetError 1000, "No file has been assigned"
    End If
End Sub

Public Sub CloseFile()
    If mbFileHasBeenAssigned Then
        Close #miFileNumber
        mbFileHasBeenAssigned = False
    Else
        coError.SetError 1000, "No file has been assigned"
    End If
End Sub

Public Sub WriteFooter()
    WriteLine " "
    WriteLine " "
    WriteLine "***********************************************"
    WriteLine "END " & mvarTitle & " ON " & Format(CDate(Now()), "YYYY-MM-DD hh:nn:ss")
    WriteLine "***********************************************"
End Sub

Public Sub WriteHeader()
    WriteLine "***********************************************"
    WriteLine "START " & mvarTitle & " ON " & Format(CDate(Now()), "YYYY-MM-DD hh:nn:ss")
    WriteLine "***********************************************"
    WriteLine " "
    WriteLine " "
End Sub


Public Sub CreateFile(ByVal Path As String, ByVal vsTitle As String)
Dim lsFile As String

    Path = Trim(Path)
    If Right(Path, 1) <> "\" Then
        Path = Path & "\"
    End If
    
    miFileNumber = FreeFile
    lsFile = Path & fsCreateFileName
    If Dir(lsFile) = "" Then
        Open lsFile For Output As #miFileNumber
    Else
        Open lsFile For Append As #miFileNumber
    End If
    
    If Dir(lsFile) <> "" Then
        mbFileHasBeenAssigned = True
    Else
        coError.SetError 1001, "File Creation failed"
    End If
    
    mvarTitle = vsTitle
End Sub

Private Function fsCreateFileName() As String
    fsCreateFileName = Format(CDate(Now()), "YYYY-MM-DD") & ".txt"
End Function


Private Sub Class_Initialize()

    Set coError = New LogError
    
End Sub

Private Sub Class_Terminate()

    If mbFileHasBeenAssigned Then
        Close #miFileNumber
        mbFileHasBeenAssigned = False
    End If
    Set coError = Nothing
    
End Sub
